/*
* Licensed to the Apache Software Foundation (ASF) under one or more
* contributor license agreements.  See the NOTICE file distributed with
* this work for additional information regarding copyright ownership.
* The ASF licenses this file to You under the Apache License, Version 2.0
* (the "License"); you may not use this file except in compliance with
* the License.  You may obtain a copy of the License at
*
*     http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
*/

    package com.ywt.gapi.third.taihe;

import org.apache.dubbo.common.stream.StreamObserver;
import com.google.protobuf.Message;

import java.util.HashMap;
import java.util.Map;
import java.util.function.BiConsumer;
import java.util.concurrent.CompletableFuture;

public interface TaiheService extends org.apache.dubbo.rpc.model.DubboStub {

    String JAVA_SERVICE_NAME = "com.ywt.gapi.third.taihe.TaiheService";
    String SERVICE_NAME = "com.ywt.gapi.third.taihe.TaiheService";

    com.ywt.gapi.third.taihe.GetPatientInfoResponse getPatientInfo(com.ywt.gapi.third.taihe.GetPatientInfoRequest request);

    default CompletableFuture<com.ywt.gapi.third.taihe.GetPatientInfoResponse> getPatientInfoAsync(com.ywt.gapi.third.taihe.GetPatientInfoRequest request){
        return CompletableFuture.completedFuture(getPatientInfo(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void getPatientInfo(com.ywt.gapi.third.taihe.GetPatientInfoRequest request, StreamObserver<com.ywt.gapi.third.taihe.GetPatientInfoResponse> responseObserver){
        getPatientInfoAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }

    com.ywt.gapi.third.taihe.CreatePatInfoResponse createPatInfo(com.ywt.gapi.third.taihe.CreatePatInfoRequest request);

    default CompletableFuture<com.ywt.gapi.third.taihe.CreatePatInfoResponse> createPatInfoAsync(com.ywt.gapi.third.taihe.CreatePatInfoRequest request){
        return CompletableFuture.completedFuture(createPatInfo(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void createPatInfo(com.ywt.gapi.third.taihe.CreatePatInfoRequest request, StreamObserver<com.ywt.gapi.third.taihe.CreatePatInfoResponse> responseObserver){
        createPatInfoAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }

    com.ywt.gapi.third.taihe.GetOutpatientListResponse getOutpatientList(com.ywt.gapi.third.taihe.GetOutpatientListRequest request);

    default CompletableFuture<com.ywt.gapi.third.taihe.GetOutpatientListResponse> getOutpatientListAsync(com.ywt.gapi.third.taihe.GetOutpatientListRequest request){
        return CompletableFuture.completedFuture(getOutpatientList(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void getOutpatientList(com.ywt.gapi.third.taihe.GetOutpatientListRequest request, StreamObserver<com.ywt.gapi.third.taihe.GetOutpatientListResponse> responseObserver){
        getOutpatientListAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }

    com.ywt.gapi.third.taihe.LockOrderResponse lockOrder(com.ywt.gapi.third.taihe.LockOrderRequest request);

    default CompletableFuture<com.ywt.gapi.third.taihe.LockOrderResponse> lockOrderAsync(com.ywt.gapi.third.taihe.LockOrderRequest request){
        return CompletableFuture.completedFuture(lockOrder(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void lockOrder(com.ywt.gapi.third.taihe.LockOrderRequest request, StreamObserver<com.ywt.gapi.third.taihe.LockOrderResponse> responseObserver){
        lockOrderAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }

    PayResponse pay(PayRequest request);

    default CompletableFuture<PayResponse> payAsync(PayRequest request){
        return CompletableFuture.completedFuture(pay(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void pay(PayRequest request, StreamObserver<PayResponse> responseObserver){
        payAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }

    com.ywt.gapi.third.taihe.PayFreeResponse payFree(com.ywt.gapi.third.taihe.PayFreeRequest request);

    default CompletableFuture<com.ywt.gapi.third.taihe.PayFreeResponse> payFreeAsync(com.ywt.gapi.third.taihe.PayFreeRequest request){
        return CompletableFuture.completedFuture(payFree(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void payFree(com.ywt.gapi.third.taihe.PayFreeRequest request, StreamObserver<com.ywt.gapi.third.taihe.PayFreeResponse> responseObserver){
        payFreeAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }

    com.ywt.gapi.third.taihe.GetScheduleListResponse getScheduleList(com.ywt.gapi.third.taihe.GetScheduleListRequest request);

    default CompletableFuture<com.ywt.gapi.third.taihe.GetScheduleListResponse> getScheduleListAsync(com.ywt.gapi.third.taihe.GetScheduleListRequest request){
        return CompletableFuture.completedFuture(getScheduleList(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void getScheduleList(com.ywt.gapi.third.taihe.GetScheduleListRequest request, StreamObserver<com.ywt.gapi.third.taihe.GetScheduleListResponse> responseObserver){
        getScheduleListAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }

    com.ywt.gapi.third.taihe.TakeResponse take(TakeRequest request);

    default CompletableFuture<com.ywt.gapi.third.taihe.TakeResponse> takeAsync(TakeRequest request){
        return CompletableFuture.completedFuture(take(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void take(TakeRequest request, StreamObserver<com.ywt.gapi.third.taihe.TakeResponse> responseObserver){
        takeAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }

    com.ywt.gapi.third.taihe.CancelResponse cancel(com.ywt.gapi.third.taihe.CancelRequest request);

    default CompletableFuture<com.ywt.gapi.third.taihe.CancelResponse> cancelAsync(com.ywt.gapi.third.taihe.CancelRequest request){
        return CompletableFuture.completedFuture(cancel(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void cancel(com.ywt.gapi.third.taihe.CancelRequest request, StreamObserver<com.ywt.gapi.third.taihe.CancelResponse> responseObserver){
        cancelAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }

    com.ywt.gapi.third.taihe.GetDiagnoseRecordResponse getDiagnoseRecord(com.ywt.gapi.third.taihe.GetDiagnoseRecordRequest request);

    default CompletableFuture<com.ywt.gapi.third.taihe.GetDiagnoseRecordResponse> getDiagnoseRecordAsync(com.ywt.gapi.third.taihe.GetDiagnoseRecordRequest request){
        return CompletableFuture.completedFuture(getDiagnoseRecord(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void getDiagnoseRecord(com.ywt.gapi.third.taihe.GetDiagnoseRecordRequest request, StreamObserver<com.ywt.gapi.third.taihe.GetDiagnoseRecordResponse> responseObserver){
        getDiagnoseRecordAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }

    com.ywt.gapi.third.taihe.RegisterResponse register(com.ywt.gapi.third.taihe.RegisterRequest request);

    default CompletableFuture<com.ywt.gapi.third.taihe.RegisterResponse> registerAsync(com.ywt.gapi.third.taihe.RegisterRequest request){
        return CompletableFuture.completedFuture(register(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void register(com.ywt.gapi.third.taihe.RegisterRequest request, StreamObserver<com.ywt.gapi.third.taihe.RegisterResponse> responseObserver){
        registerAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }






}
